Index: /branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Data/View/ColumnGroupView.Designer.cs
===================================================================
--- /branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Data/View/ColumnGroupView.Designer.cs	(revision 6706)
+++ /branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Data/View/ColumnGroupView.Designer.cs	(revision 6707)
@@ -65,4 +65,5 @@
     /// </summary>
     private void InitializeComponent() {
+      this.components = new System.ComponentModel.Container();
       System.Windows.Forms.DataGridViewCellStyle dataGridViewCellStyle1 = new System.Windows.Forms.DataGridViewCellStyle();
       System.Windows.Forms.DataGridViewCellStyle dataGridViewCellStyle2 = new System.Windows.Forms.DataGridViewCellStyle();
@@ -85,5 +86,7 @@
       this.lblStdDev = new System.Windows.Forms.Label();
       this.lblMedian = new System.Windows.Forms.Label();
+      this.toolTip = new System.Windows.Forms.ToolTip(this.components);
       ((System.ComponentModel.ISupportInitialize)(this.dataGridView)).BeginInit();
+      ((System.ComponentModel.ISupportInitialize)(this.splitContainer1)).BeginInit();
       this.splitContainer1.Panel1.SuspendLayout();
       this.splitContainer1.Panel2.SuspendLayout();
@@ -132,6 +135,6 @@
       this.txtColumnGroupName.Size = new System.Drawing.Size(397, 20);
       this.txtColumnGroupName.TabIndex = 1;
+      this.txtColumnGroupName.Click += new System.EventHandler(this.txtColumnGroupName_Click);
       this.txtColumnGroupName.DoubleClick += new System.EventHandler(this.txtColumnGroupName_DoubleClick);
-      this.txtColumnGroupName.Click += new System.EventHandler(this.txtColumnGroupName_Click);
       this.txtColumnGroupName.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txtColumnGroupName_KeyDown);
       this.txtColumnGroupName.Leave += new System.EventHandler(this.txtColumnGroupName_Leave);
@@ -321,4 +324,5 @@
       this.splitContainer1.Panel1.PerformLayout();
       this.splitContainer1.Panel2.ResumeLayout(false);
+      ((System.ComponentModel.ISupportInitialize)(this.splitContainer1)).EndInit();
       this.splitContainer1.ResumeLayout(false);
       this.tableLayoutPanel1.ResumeLayout(false);
@@ -348,4 +352,5 @@
     private System.Windows.Forms.Label label7;
     private System.Windows.Forms.Label lblStdDev;
+    private System.Windows.Forms.ToolTip toolTip;
   }
 }
Index: /branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Data/View/ColumnGroupView.cs
===================================================================
--- /branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Data/View/ColumnGroupView.cs	(revision 6706)
+++ /branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Data/View/ColumnGroupView.cs	(revision 6707)
@@ -49,4 +49,5 @@
       this.dataGridView.Dock = DockStyle.Top | DockStyle.Bottom;
       this.dataGridView.VirtualMode = true;
+      this.dataGridView.ShowCellToolTips = false;
 
       this.dataGridView.ColumnHeaderMouseClick += new DataGridViewCellMouseEventHandler(dataGridView_ColumnHeaderMouseClick);
@@ -60,4 +61,5 @@
       this.dataGridView.Resize += new EventHandler(dataGridView_Resize);
       this.dataGridView.RowHeadersWidthChanged += new EventHandler(dataGridView_RowHeadersWidthChanged);
+      this.dataGridView.CellMouseEnter += new DataGridViewCellEventHandler(dataGridView_CellMouseEnter);
 
       //delegates for virtual mode
@@ -480,4 +482,69 @@
     }
 
+    private void dataGridView_CellMouseEnter(object sender, DataGridViewCellEventArgs e) {
+      if (e.RowIndex == -1 && e.ColumnIndex != -1) {
+        toolTip.SetToolTip(this.dataGridView, ToExcelColumnIndex(e.ColumnIndex));
+      } else {
+        toolTip.Hide(this.dataGridView);
+      }
+    }
+
+
+
+    private string ToExcelColumnIndex(int index) {
+      //if (symb.Length == 1) {       // 'A' .. 'Z'
+      //  return TryTranslateColumnIndexDigit(symb[0], out columnIndex);
+      //} else if (symb.Length == 2) { // 'AA' ... 'ZZ'
+      //  bool ok;
+      //  int d0, d1;
+      //  ok = TryTranslateColumnIndexDigit(symb[0], out d1) & TryTranslateColumnIndexDigit(symb[1], out d0);
+      //  columnIndex = (d1 + 1) * 26 + d0;
+      //  return ok;
+      //} else {
+      //  columnIndex = 0;
+      //  return false;
+      //}
+      #region digits
+      var digits = new char[] { 
+        '#',
+        'A',
+        'B',
+        'C',
+        'D',
+        'E',
+        'F',
+        'G',
+        'H',
+        'I',
+        'J',
+        'K',
+        'L',
+        'M',
+        'N',
+        'O',
+        'P',
+        'Q',
+        'R',
+        'S',
+        'T',
+        'U',
+        'V',
+        'W',
+        'X',
+        'Y',
+        'Z'};
+      int b = digits.Length - 1;
+      #endregion
+      string excelIndex = string.Empty;
+      index = index + 1;
+      while (index > 0) {
+        int d = index / b;
+        int rem = index % b;
+        index = d;
+        excelIndex = digits[rem] + excelIndex;
+      }
+      return excelIndex;
+    }
+
     #region DataGridView virtual mode event handler
 