Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.Designer.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.Designer.cs	(revision 6703)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.Designer.cs	(revision 6712)
@@ -122,5 +122,5 @@
         [global::System.Configuration.UserScopedSettingAttribute()]
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("HeuristicLab.Clients.Hive.SlaveCore-3.4.dll")]
+        [global::System.Configuration.DefaultSettingValueAttribute("HeuristicLab.Clients.Hive.SlaveCore-3.3.dll")]
         public string ClientsHiveSlaveCoreDll {
             get {
@@ -134,5 +134,5 @@
         [global::System.Configuration.UserScopedSettingAttribute()]
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("HeuristicLab.Clients.Hive-3.4.dll")]
+        [global::System.Configuration.DefaultSettingValueAttribute("HeuristicLab.Clients.Hive-3.3.dll")]
         public string ClientsHiveDll {
             get {
@@ -146,5 +146,5 @@
         [global::System.Configuration.UserScopedSettingAttribute()]
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("HeuristicLab.Hive-3.4.dll")]
+        [global::System.Configuration.DefaultSettingValueAttribute("HeuristicLab.Hive-3.3.dll")]
         public string HiveDll {
             get {
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.settings
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.settings	(revision 6703)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.settings	(revision 6712)
@@ -28,11 +28,11 @@
     </Setting>
     <Setting Name="ClientsHiveSlaveCoreDll" Type="System.String" Scope="User">
-      <Value Profile="(Default)">HeuristicLab.Clients.Hive.SlaveCore-3.4.dll</Value>
+      <Value Profile="(Default)">HeuristicLab.Clients.Hive.SlaveCore-3.3.dll</Value>
     </Setting>
     <Setting Name="ClientsHiveDll" Type="System.String" Scope="User">
-      <Value Profile="(Default)">HeuristicLab.Clients.Hive-3.4.dll</Value>
+      <Value Profile="(Default)">HeuristicLab.Clients.Hive-3.3.dll</Value>
     </Setting>
     <Setting Name="HiveDll" Type="System.String" Scope="User">
-      <Value Profile="(Default)">HeuristicLab.Hive-3.4.dll</Value>
+      <Value Profile="(Default)">HeuristicLab.Hive-3.3.dll</Value>
     </Setting>
     <Setting Name="ClientsCommonDll" Type="System.String" Scope="User">
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/app_ascheibe.config
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/app_ascheibe.config	(revision 6703)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/app_ascheibe.config	(revision 6712)
@@ -10,4 +10,7 @@
     </sectionGroup>
   </configSections>
+  <startup>
+    <supportedRuntime version="v4.0" sku=".NETFramework,Version=v4.0"/>
+  </startup>
   <userSettings>
     <HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
@@ -37,11 +40,11 @@
       </setting>
       <setting name="ClientsHiveSlaveCoreDll" serializeAs="String">
-        <value>HeuristicLab.Clients.Hive.SlaveCore-3.4.dll</value>
+        <value>HeuristicLab.Clients.Hive.SlaveCore-3.3.dll</value>
       </setting>
       <setting name="ClientsHiveDll" serializeAs="String">
-        <value>HeuristicLab.Clients.Hive-3.4.dll</value>
+        <value>HeuristicLab.Clients.Hive-3.3.dll</value>
       </setting>
       <setting name="HiveDll" serializeAs="String">
-        <value>HeuristicLab.Hive-3.4.dll</value>
+        <value>HeuristicLab.Hive-3.3.dll</value>
       </setting>
       <setting name="ClientsCommonDll" serializeAs="String">
@@ -109,7 +112,3 @@
     </client>
   </system.serviceModel>
-
-  <startup>
-    <supportedRuntime version="v4.0" sku=".NETFramework,Version=v4.0"/>
-  </startup>
 </configuration>
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/app_f005pc.config
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/app_f005pc.config	(revision 6703)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/app_f005pc.config	(revision 6712)
@@ -10,4 +10,7 @@
     </sectionGroup>
   </configSections>
+  <startup>
+    <supportedRuntime version="v4.0" sku=".NETFramework,Version=v4.0"/>
+  </startup>
   <userSettings>
     <HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
@@ -37,11 +40,11 @@
       </setting>
       <setting name="ClientsHiveSlaveCoreDll" serializeAs="String">
-        <value>HeuristicLab.Clients.Hive.SlaveCore-3.4.dll</value>
+        <value>HeuristicLab.Clients.Hive.SlaveCore-3.3.dll</value>
       </setting>
       <setting name="ClientsHiveDll" serializeAs="String">
-        <value>HeuristicLab.Clients.Hive-3.4.dll</value>
+        <value>HeuristicLab.Clients.Hive-3.3.dll</value>
       </setting>
       <setting name="HiveDll" serializeAs="String">
-        <value>HeuristicLab.Hive-3.4.dll</value>
+        <value>HeuristicLab.Hive-3.3.dll</value>
       </setting>
       <setting name="ClientsCommonDll" serializeAs="String">
@@ -104,12 +107,8 @@
       <endpoint address="http://localhost/Hive-3.4/HiveService.svc" binding="wsHttpBinding" bindingConfiguration="wsHttpBinding_Hive" contract="HeuristicLab.Clients.Hive.IHiveService" name="wsHttpBinding_IHiveService">
         <identity>
-          <certificate encodedValue="AwAAAAEAAAAUAAAAfEKvcVixnJay+q4hCPFuO0JL5TQgAAAAAQAAAPIBAAAwggHuMIIBW6ADAgECAhCNN5wrUcXMmE/9xwp4TYa9MAkGBSsOAwIdBQAwFDESMBAGA1UEAxMJbG9jYWxob3N0MB4XDTEwMTAxOTEwNTMxNVoXDTM5MTIzMTIzNTk1OVowFDESMBAGA1UEAxMJbG9jYWxob3N0MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDXwC5TGcAffd/0oAWHtm0s6YXVXEgXgb1AYmBkkkhkKIFJG/e/Z0KSYbJepmSJD44W3oOAVm+x1DAsZxU79HahDYgWCuHLMm1TLpwSmYOQ0kV3pGHWHhiWV7h7oGLds/eqZ2EOpaNGryfEPnrA4VmxY91vV5/2BTeVSWG6F8lRKQIDAQABo0kwRzBFBgNVHQEEPjA8gBAR7kBnMRHO5gzThEqda0wWoRYwFDESMBAGA1UEAxMJbG9jYWxob3N0ghCNN5wrUcXMmE/9xwp4TYa9MAkGBSsOAwIdBQADgYEAoPwEG4QTDXhlxERNDfsZmM2IhEpV42ppz1kEah2oYKDa/ElIMVtvqLv6flVtg18ENN/mEJWiHZ3NyP3qr2Pip+sh+/2WBiSbOaukES/CM7OJn9kJCImH7M/xqM8pxqY8IfgM6iBVrVj9uHqj3j2BBck+cYY8fKyh3CFifMIp6ac="/>
+          <certificate encodedValue="AwAAAAEAAAAUAAAAQkazTmWcZqFuuREaov8jmDtOu4UgAAAAAQAAAPIBAAAwggHuMIIBW6ADAgECAhAVedIj+0w6jEdhZErAeemyMAkGBSsOAwIdBQAwFDESMBAGA1UEAxMJbG9jYWxob3N0MB4XDTExMDkwNjA4NDUzOVoXDTM5MTIzMTIzNTk1OVowFDESMBAGA1UEAxMJbG9jYWxob3N0MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCiKeSwXFm0qxkuMFao9NHftClUYvX0jpiyKFthUnutfhB2FF3Ie8a8U15M+GBYSZOV5vXlEn3D30HsV/x6L9/UU1fiJndJd5lWI2/4mP2jra0qP0b8xyitHfRhePIfpDkufZqIOvOmT/DoFqMTK3joexzuEmAw5Ugil6fbOxELlwIDAQABo0kwRzBFBgNVHQEEPjA8gBCJmAWIXCTyTFXdjdnseED4oRYwFDESMBAGA1UEAxMJbG9jYWxob3N0ghAVedIj+0w6jEdhZErAeemyMAkGBSsOAwIdBQADgYEACW9nLJnu1+OJg93AAKfWqkiETHcXUcULrPjMWJQsy5fkHY1qExKBGeUJHK0REvqQs3KRY3GqikMjlAnDmb/e9P1h+PynsRv7y2zAGCnKW4nryWVncWf1xJL9xvKNuH2aR4+Wdq9oo2m793+RXtA7YTSsr/OiiIdkQcjUGQtkaYo="/>
         </identity>
       </endpoint>
     </client>
   </system.serviceModel>
-
-  <startup>
-    <supportedRuntime version="v4.0" sku=".NETFramework,Version=v4.0"/>
-  </startup>
 </configuration>
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/app_services.config
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/app_services.config	(revision 6703)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/app_services.config	(revision 6712)
@@ -10,4 +10,7 @@
     </sectionGroup>
   </configSections>
+  <startup>
+    <supportedRuntime version="v4.0" sku=".NETFramework,Version=v4.0"/>
+  </startup>
   <userSettings>
     <HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
@@ -37,11 +40,11 @@
       </setting>
       <setting name="ClientsHiveSlaveCoreDll" serializeAs="String">
-        <value>HeuristicLab.Clients.Hive.SlaveCore-3.4.dll</value>
+        <value>HeuristicLab.Clients.Hive.SlaveCore-3.3.dll</value>
       </setting>
       <setting name="ClientsHiveDll" serializeAs="String">
-        <value>HeuristicLab.Clients.Hive-3.4.dll</value>
+        <value>HeuristicLab.Clients.Hive-3.3.dll</value>
       </setting>
       <setting name="HiveDll" serializeAs="String">
-        <value>HeuristicLab.Hive-3.4.dll</value>
+        <value>HeuristicLab.Hive-3.3.dll</value>
       </setting>
       <setting name="ClientsCommonDll" serializeAs="String">
@@ -109,7 +112,3 @@
     </client>
   </system.serviceModel>
-
-  <startup>
-    <supportedRuntime version="v4.0" sku=".NETFramework,Version=v4.0"/>
-  </startup>
 </configuration>